#Competitive methods: Cox model and AFT model
library(survival)
library(pROC)
library(randomForestSRC)
#Univ: fit model univariately (with interaction)
#All: fit model based on all covariates (with interaction)
##############################Cox model_UniV############################## 
##############################Cox model_UniV############################## 
##############################Cox model_UniV############################## 
Cox.univ.fit=NULL
for (k in 1:p) {
  Zintr_k=mydata[,nameid[k]]*mydata[,5]
  names(Zintr_k)=paste0(nameM[k],"_intr")
  Coxdata_k=data.frame(mydata[,c(1,2,3,5,5+k)],Zintr_k)
  name.cox_k <- names(Coxdata_k[,-c(1:3)])
  f.cox_k <- as.formula(paste("Surv(time, status)~", paste(name.cox_k, collapse = " + ")))
  Cox.fit_k=coxph(f.cox_k, data=Coxdata_k)
  COX_k=summary(Cox.fit_k)[["coefficients"]][,-2]
  cox.CI_k=confint(Cox.fit_k)
  cox.result_k=cbind(COX_k,cox.CI_k)
  Cox.univ.fit=rbind(Cox.univ.fit,cox.result_k)
}
Cox.univ.fit=Cox.univ.fit[c(3*(1:p)-1,3*(1:p)),]
Cox.univ.cvrt=as.numeric(apply(cbind(-c(Beta[-c(1:2)],Beta_intr)/scale,Cox.univ.fit[,5:6]), 1, BETWEENAll))
Cox.univ.fit=cbind(Cox.univ.fit,Cox.univ.cvrt)
colnames(Cox.univ.fit)=c("Est","Se","z","p","CIL","CIU","Cvrt")
##############################Cox model_All############################## 
##############################Cox model_All############################## 
##############################Cox model_All############################## 
Zallintr=mydata[,nameid]*mydata[,"Trt"]
colnames(Zallintr)=paste0(nameM,"_intr")
Coxdata.all=data.frame(mydata,Zallintr)
Coxdata.all=Coxdata.all[,-4]
name.cox <- names(Coxdata.all[,-c(1:3)])
f.cox <- as.formula(paste("Surv(time, status)~", paste(name.cox, collapse = " + ")))
cox.fit.all=coxph(f.cox, data=Coxdata.all)
COXALL=summary(cox.fit.all)[["coefficients"]][,-2]
asyN.cox=confint(cox.fit.all)
Cox.all.cvrt=as.numeric(apply(cbind(-c(Beta[-1],Beta_intr)/scale,asyN.cox), 1, BETWEENAll))
Cox.all.fit=cbind(COXALL,asyN.cox,Cox.all.cvrt)
colnames(Cox.all.fit)=c("Est","Se","z","p","CIL","CIU","Cvrt")

##############################AFT model_UniV##############################
##############################AFT model_UniV############################## 
##############################AFT model_UniV############################## 
Aft.univ.fit=NULL
for (k in 1:p) {
  Zintr_k=mydata[,nameid[k]]*mydata[,5]
  names(Zintr_k)=paste0(nameM[k],"_intr")
  Aftdata_k=data.frame(mydata[,c(1,2,3,5,5+k)],Zintr_k)
  name.aft_k <- names(Aftdata_k[,-c(1:3)])
  f.aft_k <- as.formula(paste("Surv(time, status)~", paste(name.aft_k, collapse = " + ")))
  fit.aft_k <- survreg(f.aft_k, Aftdata_k, dist = "weibull")
  AFT_k=summary(fit.aft_k)[["table"]][-dim(summary(fit.aft_k)[["table"]])[1],]
  asyN.aft_k=confint(fit.aft_k)
  cvrt.aft_k=apply(cbind(c(Beta[c(1,2,k+2)],Beta_intr[k]),asyN.aft_k),1,BETWEENAll)
  Aft.fit_k=cbind(AFT_k,asyN.aft_k,cvrt.aft_k)
  Aft.univ.fit=rbind(Aft.univ.fit,Aft.fit_k)
}
Aft.univ.fit=Aft.univ.fit[c(4*(1:p)-1,4*(1:p)),]
colnames(Aft.univ.fit)=c("Aft.univ.est","Aft.univ.est.se","Aft.univ.z","Aft.univ.p", "Aft.univ.CI.L","Aft.univ.CI.U","Aft.univ.cvrt")

##############################AFT model_All##############################
##############################AFT model_All############################## 
##############################AFT model_All############################## 
AFTdata.all=Coxdata.all
name.aft <- colnames(AFTdata.all[,-c(1:3)])
f.aft <- as.formula(paste("Surv(time, status)~", paste(name.aft, collapse = " + ")))
aftresult=function(data){
  fit.aft.all <- survreg(f.aft, data, dist = "weibull")
  AFTALL=summary(fit.aft.all)[["table"]][-(1+2+2*p),]
  asyN.aft=confint(fit.aft.all)
  cvrt.aft.all=apply(cbind(c(Beta,Beta_intr),asyN.aft),1,BETWEENAll)
  Aft.all.fit=cbind(AFTALL,asyN.aft,cvrt.aft.all)
  colnames(Aft.all.fit)=c("Aft.all.est","Aft.all.est.se","Aft.all.z","Aft.all.p", "Aft.all.CI.L","Aft.all.CI.U","Aft.all.cvrt")
  return(Aft.all.fit)
}
Aft.all.fit=aftresult(AFTdata.all)

########################################AFT model_All Two Sample (TS)########################################
########################################AFT model_All Two Sample (TS)########################################
########################################AFT model_All Two Sample (TS)########################################
Zintr1.out=CBT0.TS[,-c(1:6)]*CBT0.TS[,"Trt"]
colnames(Zintr1.out)=colnames(Zallintr)
Zintr0.out=SBT0.TS[,-c(1:6)]*SBT0.TS[,"Trt"]
colnames(Zintr0.out)=colnames(Zallintr) 
Z.pred1.out=cbind(CBT0.TS[,-c(1:5)],Zintr1.out)
Z.pred0.out=cbind(SBT0.TS[,-c(1:5)],Zintr0.out)
TSaftresult=function(data){
  fit.aft.all <- survreg(f.aft, data, dist = "weibull")
  pred1.aft.out=predict(fit.aft.all,newdata = Z.pred1.out)
  pred0.aft.out=predict(fit.aft.all,newdata = Z.pred0.out)
  pred.aft.out=log(pred1.aft.out)-log(pred0.aft.out)
  
  mse.aft.out=sqrt(mean((dLogTime.TS-pred.aft.out)^2))
  if(length(unique(as.numeric(dLogTime.TS>0)))!=2){
    auc.aft.out=0.5
  }else{auc.aft.out=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.aft.out>0),direction = "<"))}
  TS.aft.all=c(mse.aft.out,auc.aft.out)
  return(TS.aft.all)
  
}
TS.aft.all=TSaftresult(AFTdata.all)
########################################AFT model_All Out-of-Bag (OOB)########################################
########################################AFT model_All Out-of-Bag (OOB)########################################
########################################AFT model_All Out-of-Bag (OOB)########################################
OOBAFTall=function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(dLogTime[x.out]>0))!=2){
    while (length(unique(dLogTime[x.out]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  Zintr1.in=CBT0[x.in,-c(1:5)]*CBT0[x.in,5]
  colnames(Zintr1.in)=colnames(Zallintr)
  Zintr0.in=SBT0[x.in,-c(1:5)]*SBT0[x.in,5]
  colnames(Zintr0.in)=colnames(Zallintr) 
  Zintr.censored=mydata[which(mydata[,"status"]==0),-c(1:5)]*mydata[which(mydata[,"status"]==0),5]
  colnames(Zintr.censored)=colnames(Zallintr) 
  censoreddata=cbind(mydata[which(mydata[,"status"]==0),-c(1,4)],Zintr.censored)
  censoreddata=censoreddata[sample(1:dim(censoreddata)[1],size=dim(censoreddata)[1],replace=TRUE),]
  
  Zintr1.out=CBT0[x.out,-c(1:5)]*CBT0[x.out,5]
  colnames(Zintr1.out)=colnames(Zallintr)
  Zintr0.out=SBT0[x.out,-c(1:5)]*SBT0[x.out,5]
  colnames(Zintr0.out)=colnames(Zallintr) 
  Z.pred1_b=cbind(CBT0[x.out,-c(1:4)],Zintr1.out)
  Z.pred0_b=cbind(SBT0[x.out,-c(1:4)],Zintr0.out)
  
  aftdata.in=rbind(
    cbind(CBT0[x.in,-c(1,4)],Zintr1.in),
    cbind(SBT0[x.in,-c(1,4)],Zintr0.in),
    censoreddata)
  
  regresult=function(data){
    fit.aft.all_b <- survreg(f.aft, aftdata.in, dist = "weibull")
    
    pred1_b=predict(fit.aft.all_b,newdata = Z.pred1_b)
    pred0_b=predict(fit.aft.all_b,newdata = Z.pred0_b)
    
    pred.out=log(pred1_b)-log(pred0_b)
    if(sum(pred.out)=="NaN" | sum(pred.out)=="-Inf"| sum(pred.out)=="Inf"| sum(abs(pred.out))>1000){
      mse_b=sum((dLogTime[x.out])^2)
      auc_b=0.5
    }else{
      mse_b=sum((dLogTime[x.out]-pred.out)^2)
      auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
    }
    n.out_b=length(x.out)
    return(c(mse_b,n.out_b,auc_b))
  }
  return(regresult(aftdata.in))
  
}        
OOB.aft.all=apply(bootsamid1, 1, OOBAFTall)
########################################Cox model_All Two-Sample (TS)########################################
########################################Cox model_All Two-Sample (TS)########################################
########################################Cox model_All Two-Sample (TS)########################################
pred1.cox.out=predict(cox.fit.all, newdata=Z.pred1.out, type="lp")
pred0.cox.out=predict(cox.fit.all, newdata=Z.pred0.out, type="lp")

pred.cox.out=pred1.cox.out-pred0.cox.out
if(length(unique(as.numeric(dLogTime.TS>0)))!=2){
  auc.cox.out=0.5
}else{auc.cox.out=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.cox.out<0),direction = "<"))}
TS.cox.all=c(0,auc.cox.out)

########################################Cox model_All Out-of-Bag (OOB)########################################
########################################Cox model_All Out-of-Bag (OOB)########################################
########################################Cox model_All Out-of-Bag (OOB)########################################
OOBCOXall=function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(dLogTime[x.out]>0))!=2){
    while (length(unique(dLogTime[x.out]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  Zintr1.in=CBT0[x.in,-c(1:5)]*CBT0[x.in,5]
  colnames(Zintr1.in)=colnames(Zallintr)
  Zintr0.in=SBT0[x.in,-c(1:5)]*SBT0[x.in,5]
  colnames(Zintr0.in)=colnames(Zallintr) 
  Zintr.censored=mydata[which(mydata[,"status"]==0),-c(1:5)]*mydata[which(mydata[,"status"]==0),5]
  colnames(Zintr.censored)=colnames(Zallintr) 
  censoreddata=cbind(mydata[which(mydata[,"status"]==0),-c(1,4)],Zintr.censored)
  censoreddata=censoreddata[sample(1:dim(censoreddata)[1],size=dim(censoreddata)[1],replace=TRUE),]
  
  Zintr1.out=CBT0[x.out,-c(1:5)]*CBT0[x.out,5]
  colnames(Zintr1.out)=colnames(Zallintr)
  Zintr0.out=SBT0[x.out,-c(1:5)]*SBT0[x.out,5]
  colnames(Zintr0.out)=colnames(Zallintr) 
  Z.pred1_b=cbind(CBT0[x.out,-c(1:4)],Zintr1.out)
  Z.pred0_b=cbind(SBT0[x.out,-c(1:4)],Zintr0.out)
  dZ.pred.out_b=Z.pred1_b-Z.pred0_b
  
  coxdata.in=rbind(
    cbind(CBT0[x.in,-c(1,4)],Zintr1.in),
    cbind(SBT0[x.in,-c(1,4)],Zintr0.in),
    censoreddata)
  
  cox.fit.all_b=coxph(f.cox, data=coxdata.in)
  pred1.cox.out=predict(cox.fit.all_b, newdata=Z.pred1_b, type="lp")
  pred0.cox.out=predict(cox.fit.all_b, newdata=Z.pred0_b, type="lp")
  
  pred.cox.out=pred1.cox.out-pred0.cox.out
  
  if(length(unique(as.numeric(dLogTime[x.out]>0)))!=2){
    auc.cox.out=0.5
  }else{auc.cox.out=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.cox.out<0),direction = "<"))}
  return(auc.cox.out)
  
}        
OOB.cox.all=apply(bootsamid1, 1, OOBCOXall)
########################################Random Survival Forest_All Two-Sample (TS)########################################
########################################Random Survival Forest_All Two-Sample (TS)########################################
########################################Random Survival Forest_All Two-Sample (TS)########################################
median.TS=median(mydata1.TS[,"time"])
median.OOB=median(mydata1[,"time"])
f.rsf <- as.formula(paste("Surv(time, status)~", paste(colnames(Coxdata.all)[-c(1:3)], collapse = " + ")))
rfsrc <- rfsrc(f.rsf, data = Coxdata.all, nsplit = 10, na.action = "na.impute",tree.err = TRUE,importance = TRUE)
Coxdata.all.TS=data.frame(mydata1.TS[,-c(4:5)],mydata1.TS[,-c(1:6)]*mydata1.TS[,"Trt"])
colnames(Coxdata.all.TS)=colnames(Coxdata.all)
rfsrc_test <- predict(rfsrc, newdata = Coxdata.all.TS[,-c(1:3)], na.action = "na.impute", importance = TRUE)

survivalfunction=rfsrc_test[["survival"]]
rank_obstime=sapply(rep(median.TS,n),function(k){max(1,min(max(which(sort(rfsrc_test[["time.interest"]])<=k))+1,length(rfsrc_test[["time.interest"]])))})

survival.pred=NULL
for (i in 1:n) {
  survival.pred=rbind(survival.pred,survivalfunction[i,rank_obstime[i]])
}
rownames(survival.pred)=c(1:n)
pred.rsf=survival.pred[pair.TS0[,1],]-survival.pred[pair.TS0[,2],]
ts.auc.rsf=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.rsf<0),direction = ">"))
TS.rsf=c(0,ts.auc.rsf)
########################################Random Survival Forest_All Out-of-Bag (OOB)########################################
########################################Random Survival Forest_All Out-of-Bag (OOB)########################################
########################################Random Survival Forest_All Out-of-Bag (OOB)########################################
Pred.rsf = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  
  Zintr1.in=CBT0[x.in,-c(1:5)]*0.5
  colnames(Zintr1.in)=colnames(Zallintr)
  Zintr0.in=SBT0[x.in,-c(1:5)]*(-0.5)
  colnames(Zintr0.in)=colnames(Zallintr) 
  Zintr.censored=mydata[which(mydata[,"status"]==0),-c(1:5)]*mydata[which(mydata[,"status"]==0),"Trt"]
  colnames(Zintr.censored)=colnames(Zallintr) 
  censoreddata=cbind(mydata[which(mydata[,"status"]==0),-c(1,4)],Zintr.censored)
  censoreddata=censoreddata[sample(1:dim(censoreddata)[1],size=dim(censoreddata)[1],replace=TRUE),]
  
  Zintr1.out=CBT0[x.out,-c(1:5)]*0.5
  colnames(Zintr1.out)=colnames(Zallintr)
  Zintr0.out=SBT0[x.out,-c(1:5)]*(-0.5)
  colnames(Zintr0.out)=colnames(Zallintr) 
  Z.pred1_b=cbind(CBT0[x.out,-c(1:4)],Zintr1.out)
  Z.pred0_b=cbind(SBT0[x.out,-c(1:4)],Zintr0.out)
  
  aftdata.in=rbind(
    cbind(CBT0[x.in,-c(1,4)],Zintr1.in),
    cbind(SBT0[x.in,-c(1,4)],Zintr0.in),
    censoreddata)
  
  f.rsf <- as.formula(paste("Surv(time, status)~", paste(colnames(aftdata.in)[-c(1:2)], collapse = " + ")))
  rfsrc <- rfsrc(f.rsf, data = aftdata.in, nsplit = 10, na.action = "na.impute", tree.err = TRUE, importance = TRUE)
  
  rfsrc_test1 <- predict(rfsrc, newdata = Z.pred1_b, na.action = "na.impute", importance = TRUE)
  survivalfunction1=rfsrc_test1[["survival"]]
  rank_obstime1=sapply(rep(median.OOB,length(x.out)),function(k){max(1,min(max(which(sort(rfsrc_test1[["time.interest"]])<=k))+1,length(rfsrc_test1[["time.interest"]])))})
  survival.pred1=NULL
  for (i in 1:length(x.out)) {
    survival.pred1=rbind(survival.pred1,survivalfunction1[i,rank_obstime1[i]])
  }
  
  rfsrc_test0 <- predict(rfsrc, newdata = Z.pred0_b, na.action = "na.impute", importance = TRUE)
  survivalfunction0=rfsrc_test0[["survival"]]
  rank_obstime0=sapply(rep(median.OOB,length(x.out)),function(k){max(1,min(max(which(sort(rfsrc_test0[["time.interest"]])<=k))+1,length(rfsrc_test0[["time.interest"]])))})
  survival.pred0=NULL
  for (i in 1:length(x.out)) {
    survival.pred0=rbind(survival.pred0,survivalfunction0[i,rank_obstime0[i]])
  }
  
  auc.rsf=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(survival.pred1-survival.pred0<0),direction = ">"))
  return(auc.rsf)
}
OOB.rsf=apply(bootsamid1, 1, Pred.rsf)

############################################################
############################################################
############################################################
#Summarize Evaluation results
TS=matrix(0,3,2)
TS[1,]=TS.cox.all
TS[2,]=TS.aft.all
TS[3,]=TS.rsf
rownames(TS)=c("Cox","AFT","RSF")
colnames(TS)=c("TSPE","TSAUC")
OOB.cox.all=c(0,mean(OOB.cox.all))
OOB.aft.all=c(mean(sqrt(OOB.aft.all[1,]/OOB.aft.all[2,])),mean(OOB.aft.all[3,]))
OOB.rsf=c(0,mean(OOB.rsf))
OOB=matrix(0,3,2)
OOB[1,]=OOB.cox.all
OOB[2,]=OOB.aft.all
OOB[3,]=OOB.rsf
rownames(OOB)=c("Cox","AFT","RSF")
colnames(OOB)=c("OOBPE","OOBAUC")
Evaluation=round(cbind(TS,OOB),2)
#Summarize Estimation results
Estimation=round(cbind(c(Beta[3:17],Beta_intr),Aft.univ.fit[,1:2],
                       Aft.all.fit[-c(1:2),1:2],
                       Cox.univ.fit[,1:2],
                       Cox.all.fit[-1,1:2]),2)
colnames(Estimation)=c("TRUE","AFTU_Est","AFTU_SE", "AFTAll_Est","AFTAll_SE","CoxU_Est","CoxU_SE","CoxAll_Est","CoxAll_SE")
rownames(Estimation)=rownames(Cox.all.fit)[-1]

Estimation
Evaluation
