#Proposed matched-weighting estimators (MW)
library(glmnet)
library(randomForest)
library(survival)
library(pROC)
library(randomForestSRC)
#######################################MW.OLS_DA_UniV##########################
#######################################MW.OLS_DA_UniV##########################
#######################################MW.OLS_DA_UniV##########################
#######################################MW.OLS_DA_UniV##########################

catid=c(4,5,14,15)
est.Matched_DA=NULL
Bts.est.Matched_DA=NULL
bcBts.est.Matched_DA=NULL
Bts.asyN.CI_DA=NULL
Bts.sd.Matched_DA=NULL
cvrtDA.UniV=NULL
selectorDA=NULL
corrdM=NULL
corraM=NULL
for (k in 1:p) {
  thetaDA = function(x,data){
    name <- names(data)[-1]
    f <- as.formula(paste("dLogTime~", paste(name, collapse = " + ")))
    fit = glm(f, weight=wgt[x], data=data[x,])
    coefv = fit[["coefficients"]]
    coefv[which(is.na(coefv))]=0
    return(coefv)
  }
  #######pick the kth moderator
  pairdata.da_k=pairdata[,c(1,1+k,1+p+k)]
  name.da_k <- names(pairdata.da_k)[-1]
  f.da_k <- as.formula(paste("dLogTime~", paste(name.da_k, collapse = " + ")))
  
  fit2k=glm(f.da_k, weight=wgt, data=pairdata.da_k)
  
  if(is.na(fit2k[["coefficients"]][[2]])){
    summaryfit2k=apply(summary(fit2k)[["coefficients"]],2,assignbeta,count=c(1,0,1))
  }else{
    summaryfit2k=summary(fit2k)[["coefficients"]]
  }
  rownames(summaryfit2k)=c("(Intercept)",name.da_k)
  est.Matched_DA=rbind(est.Matched_DA,summaryfit2k)
  
  thetastarDA_k=apply(bootsamid1,1,thetaDA,data=pairdata.da_k)
  #bootstrap mean 
  btsmeanDA_k=as.matrix(rowMeans(thetastarDA_k))
  Bts.est.Matched_DA=cbind(Bts.est.Matched_DA,btsmeanDA_k)
  #bootstrap sd
  btssdDA_k=apply(thetastarDA_k,1,sd)
  Bts.sd.Matched_DA=cbind(Bts.sd.Matched_DA,btssdDA_k)
  #calculate z value
  selectda=summaryfit2k[,"Estimate"]/btssdDA_k
  selectda=ifelse(is.nan(selectda),0,selectda)
  selectorDA=cbind(selectorDA,selectda)
  #simple corrected bootstrap mean
  bcbtsmeanDA_k=2*summaryfit2k[,"Estimate"]-btsmeanDA_k
  bcBts.est.Matched_DA=cbind(bcBts.est.Matched_DA,bcbtsmeanDA_k)
  #bootstrap asymptotic Normal CI
  asybtsqDA_k=cbind(btsmeanDA_k-apply(thetastarDA_k,1,sd)*qnorm(0.975),
                    btsmeanDA_k-apply(thetastarDA_k,1,sd)*qnorm(0.025))
  Bts.asyN.CI_DA=cbind(Bts.asyN.CI_DA,asybtsqDA_k) 
  
  #bootstrap asymptotic Normal CI coverage count         
  cvrtDA.UniV_k=as.numeric(c(BETWEEN(Beta[2],asybtsqDA_k[1,]),
                             BETWEEN(Beta[2+k],asybtsqDA_k[2,]),
                             BETWEEN(Beta_intr[k],asybtsqDA_k[3,])))
  
  cvrtDA.UniV=cbind(cvrtDA.UniV,cvrtDA.UniV_k)
  
  d2=summaryfit2k[,"Estimate"][names(DZ)[k]]/sigma(fit2k)
  d3=summaryfit2k[,"Estimate"][names(AZ)[k]]/sigma(fit2k)
  if(k%in%catid){
    p_hat_k=table(mydata[,5+k])["0.5"]/nrow(mydata)
    cdM=d2/sqrt(d2^2+d3^2/4+1/(p_hat_k*(1-p_hat_k)))
    caM=d3/(2*sqrt(d2^2+d3^2/4+1/(p_hat_k*(1-p_hat_k))))
  }else{
    cdM=d2/sqrt(d2^2+d3^2/4+1)
    caM=d3/(2*sqrt(d2^2+d3^2/4+1))
  }
  
  corrdM=rbind(corrdM,cdM)
  corraM=rbind(corraM,caM)
}


resultDAdm=NULL
for (k in 1:p) {
  resultDAdm=rbind(resultDAdm,c(
    est.Matched_DA[colnames(DZ)[k],],
    Bts.est.Matched_DA["d_Z1",k],
    Bts.sd.Matched_DA["d_Z1",k],
    bcBts.est.Matched_DA["d_Z1",k],
    Bts.asyN.CI_DA["d_Z1",(2*(k-1)+1):(2*(k-1)+2)],
    cvrtDA.UniV[2,k],
    selectorDA["d_Z1",k]))
}
resultDAdm=cbind(resultDAdm,corrdM)
colnames(resultDAdm)=c("Estimate","Std.Error","t","p","btsmean","btssd","bcbtsmean","btsCIL","btsCIU","cvrtDA.UniV","selectorDA","Rho_M")
rownames(resultDAdm)=colnames(DZ)

resultDAam=NULL
for (k in 1:p) {
  resultDAam=rbind(resultDAam,c(
    est.Matched_DA[colnames(AZ)[k],],
    Bts.est.Matched_DA["a_Z1",k],
    Bts.sd.Matched_DA["a_Z1",k],
    bcBts.est.Matched_DA["a_Z1",k],
    Bts.asyN.CI_DA["a_Z1",(2*(k-1)+1):(2*(k-1)+2)],
    cvrtDA.UniV[3,k],
    selectorDA["a_Z1",k]))
}
resultDAam=cbind(resultDAam,corraM)
colnames(resultDAam)=c("Estimate","Std.Error","t","p","btsmean","btssd","bcbtsmean","btsCIL","btsCIU","cvrtDA.UniV","selectorDA","Rho_M")
rownames(resultDAam)=colnames(AZ)

resultDA=round(rbind(resultDAdm,resultDAam),3)
selectDA=resultDA



#######################################MW.OLS_A only_UniV##########################
#######################################MW.OLS_A only_UniV##########################
#######################################MW.OLS_A only_UniV##########################

est.Matched_A=NULL
Bts.est.Matched_A=NULL
bcBts.est.Matched_A=NULL
Bts.asyN.CI_A=NULL
Bts.sd.Matched_A=NULL
cvrtA.UniV=NULL
selectorA=NULL
corraM_A=NULL
for (k in 1:p) {
  thetaA = function(x,data){
    name <- names(data)[-1]
    f <- as.formula(paste("dLogTime~", paste(name, collapse = " + ")))
    fit = glm(f,weight=wgt[x], data=data[x,])
    coefv = fit[["coefficients"]]
    coefv[which(is.na(coefv))]=0
    return(coefv)
  }
  #######pick the kth moderator
  pairdata.a_k=pairdata[,c(1,1+p+k)]
  name.a_k <- names(pairdata.a_k)[-1]
  f.a_k <- as.formula(paste("dLogTime~", paste(name.a_k, collapse = " + ")))
  fit3k=glm(f.a_k,weight=wgt, data=pairdata.a_k)
  est.Matched_A=rbind(est.Matched_A,summary(fit3k)[["coefficients"]])
  ####1000 bootstrap samples
  thetastarA_k=apply(bootsamid1,1,thetaA,data=pairdata.a_k)
  #bootstrap mean 
  btsmeanA_k=as.matrix(rowMeans(thetastarA_k[,, drop = FALSE]))
  Bts.est.Matched_A=cbind(Bts.est.Matched_A,btsmeanA_k)
  #bootstrap sd
  btssdA_k=apply(thetastarA_k,1,sd)
  Bts.sd.Matched_A=cbind(Bts.sd.Matched_A,btssdA_k)
  #calculate z value
  selectorA=cbind(selectorA,summary(fit3k)[["coefficients"]][,1]/btssdA_k)
  #simple corrected bootstrap mean
  bcbtsmeanA_k=2*summary(fit3k)[["coefficients"]][,1]-btsmeanA_k
  bcBts.est.Matched_A=cbind(bcBts.est.Matched_A,bcbtsmeanA_k)
  #bootstrap asymptotic Normal CI
  asybtsqA_k=cbind(btsmeanA_k-apply(thetastarA_k,1,sd)*qnorm(0.975),
                   btsmeanA_k-apply(thetastarA_k,1,sd)*qnorm(0.025))
  Bts.asyN.CI_A=cbind(Bts.asyN.CI_A,asybtsqA_k)      
  #bootstrap asymptotic Normal CI coverage count         
  cvrtA.UniV_k=as.numeric(c(BETWEEN(Beta[2],asybtsqA_k[1,]),
                            BETWEEN(Beta_intr[k],asybtsqA_k[2,])))
  
  cvrtA.UniV=cbind(cvrtA.UniV,cvrtA.UniV_k)
  d3_A=fit3k[["coefficients"]][names(AZ)[k]]/sigma(fit3k)
  if(k%in%c(4,5,14,15)){
    p_hat_k=table(mydata[,5+k])["0.5"]/nrow(mydata)
    caM_A=d3_A/(2*sqrt(d3_A^2/4+1/(p_hat_k*(1-p_hat_k))))
  }else{
    caM_A=d3_A/(2*sqrt(d3_A^2/4+1))
  }
  
  corraM_A=rbind(corraM_A,caM_A)
}
######format results
resultA=NULL
for (k in 1:p) {
  resultA=rbind(resultA,c(
    est.Matched_A[colnames(AZ)[k],],
    Bts.est.Matched_A["a_Z1",k],
    Bts.sd.Matched_A["a_Z1",k],
    bcBts.est.Matched_A["a_Z1",k],
    Bts.asyN.CI_A["a_Z1",(2*(k-1)+1):(2*(k-1)+2)],
    cvrtA.UniV[2,k],
    selectorA["a_Z1",k])
  )
  
}
resultA=cbind(resultA,corraM_A)
colnames(resultA)=c("Estimate","Std.Error","t","p","btsmean","btssd","bcbtsmean","btsCIL","btsCIU","cvrtA.UniV","selectorA","Rho_aM")
rownames(resultA)=colnames(AZ)
selectA=resultA

######################## MW.OLS_DA_All ########################################
######################## MW.OLS_DA_All ########################################
######################## MW.OLS_DA_All ########################################
######################## Matched fit all ########################################
######################## Matched fit all ########################################
######################## Matched fit all ########################################
name.all.DA<- colnames(pairdata)[-1]
f.all.DA <- as.formula(paste("dLogTime~", paste(name.all.DA, collapse = " + ")))
fit.all.DA=glm(f.all.DA,weight=wgt,data=pairdata)

if(is.na(sum(fit.all.DA[["coefficients"]]))){
  summaryfitallda=apply(summary(fit.all.DA)[["coefficients"]],2,assignbeta,count=1-as.numeric(is.na(fit.all.DA[["coefficients"]])))
}else{
  summaryfitallda=summary(fit.all.DA)[["coefficients"]]
}
rownames(summaryfitallda)=c("(Intercept)",name.all.DA)

thetaAll.DA = function(x,data){
  name <- names(data)[-1]
  f <- as.formula(paste("dLogTime~", paste(name, collapse = " + ")))
  fit = glm(f,weight=wgt[x], data=data[x,])
  coefv = fit[["coefficients"]]
  coefv[which(is.na(coefv))]=0
  return(coefv)
}

thetastar.all.DA=apply(bootsamid1,1,thetaAll.DA,data=pairdata)
#bootstrap mean 
btsmean.all.DA=as.matrix(rowMeans(thetastar.all.DA))
#bootstrap sd
btssd.all.DA=apply(thetastar.all.DA,1,sd)
#simple corrected bootstrap mean
bcbtsmean.all.DA=2*summaryfitallda[,"Estimate"]-btsmean.all.DA
#bootstrap asymptotic Normal CI
asybts.all.DA=cbind(btsmean.all.DA-btssd.all.DA*qnorm(0.975),
                    btsmean.all.DA-btssd.all.DA*qnorm(0.025))


result.all.DA=cbind(
  summaryfitallda,
  btsmean.all.DA,
  btssd.all.DA,
  bcbtsmean.all.DA,
  asybts.all.DA)
result.all.DA=cbind(True=c(Beta[-1],Beta_intr),result.all.DA)
colnames(result.all.DA)=c("True","est","est.se","t","p","bts.est","bts.sd","bcbts.est","bts.asy.L","bts.asy.U")
cvrt.all.DA=as.numeric(apply(cbind(c(Beta[-1],Beta_intr),result.all.DA[,c("bts.asy.L","bts.asy.U")]), 1, BETWEENAll))
result.all.DA=cbind(result.all.DA,cvrt.all.DA)

########glm_fit all_A only
pairdata.all.A=pairdata[,-c(2:(1+p))]
name.all.A<- names(pairdata.all.A)[-1]
f.all.A <- as.formula(paste("dLogTime~", paste(name.all.A, collapse = " + ")))
fit.all.A=glm(f.all.A,weight=wgt,data=pairdata.all.A)

thetaAll.A = function(x,data){
  name <- names(data)[-1]
  f <- as.formula(paste("dLogTime~", paste(name, collapse = " + ")))
  fit = glm(f,weight=wgt[x], data=data[x,])
  coefv = fit[["coefficients"]]
  coefv[which(is.na(coefv))]=0
  return(coefv)
}

thetastar.all.A=apply(bootsamid1,1,thetaAll.A,data=pairdata.all.A)
#bootstrap mean 
btsmean.all.A=as.matrix(rowMeans(thetastar.all.A))
#bootstrap sd
btssd.all.A=apply(thetastar.all.A,1,sd)
#simple corrected bootstrap mean
bcbtsmean.all.A=2*summary(fit.all.A)[["coefficients"]][,1]-btsmean.all.A
#bootstrap asymptotic Normal CI
asybts.all.A=cbind(btsmean.all.A-btssd.all.A*qnorm(0.975),
                   btsmean.all.A-btssd.all.A*qnorm(0.025))

result.all.A=cbind(
  summary(fit.all.A)[["coefficients"]],
  btsmean.all.A,
  btssd.all.A,
  bcbtsmean.all.A,
  asybts.all.A)
result.all.A=cbind(True=c(Beta[2],Beta_intr),result.all.A)
colnames(result.all.A)=c("True","est","est.se","t","p","bts.est","bts.sd","bcbts.est","bts.asy.L","bts.asy.U")
cvrt.all.A=as.numeric(apply(cbind(c(Beta[2],Beta_intr),result.all.A[,c("bts.asy.L","bts.asy.U")]), 1, BETWEENAll))
result.all.A=cbind(result.all.A,cvrt.all.A)


########################  MW.OLS_SDA_All########################################
########################  MW.OLS_SDA_All########################################
########################  MW.OLS_SDA_All########################################
thd=1
selectDAOOB=function(threshold){
  #################if select based on A+D, also contain D and A in combined terms################
  count_cm.da.am=as.numeric(abs(resultDAam[,"selectorDA"])>threshold)
  count_cm.da.dm=as.numeric(abs(resultDAdm[,"selectorDA"])>threshold | abs(resultDAam[,"selectorDA"])>threshold)
  count_cm.da=c(count_cm.da.dm,count_cm.da.am)
  
  f.cm.da <- as.formula(paste("dLogTime~", paste(c(colnames(DZ),colnames(AZ))[ifelse(count_cm.da==1,TRUE,FALSE)], collapse = " + ")))
  fit.cm.da=glm(f.cm.da, weight=wgt,data=pairdata)
  
  ##############################################
  #OOB CM DA ###################################
  ##############################################
  Predcm.DA = function(x.in){
    x.out=c(1:npair)[-unique(x.in)]
    if(length(unique(pairdata[x.out,1]>0))!=2){
      while (length(unique(pairdata[x.out,1]>0))!=2){
        x.in=sample(1:npair,size=npair,replace=TRUE)
        x.out=c(1:npair)[-unique(x.in)]
      }
    }
    ####UniV############
    selector_DA.am_b=NULL
    selector_DA.dm_b=NULL
    for (k in 1:p) {
      #######pick the kth moderator
      pairdata.da_b_k=pairdata[x.in,c(1,1+k,1+p+k)]
      name.da_b_k <- names(pairdata.da_b_k)[-1]
      f.da_b_k <- as.formula(paste("dLogTime~", paste(name.da_b_k, collapse = " + ")))
      fit2k_b=glm(f.da_b_k,weight=wgt[x.in], data=pairdata.da_b_k)
      if(is.na(fit2k_b[["coefficients"]][2])){
        selector_DA.dm_b=rbind(selector_DA.dm_b,0)
      }else{selector_DA.dm_b=rbind(selector_DA.dm_b,summary(fit2k_b)[["coefficients"]][name.da_b_k[1],3])}
      
      if(is.na(fit2k_b[["coefficients"]][3])){
        selector_DA.am_b=rbind(selector_DA.am_b,0)
      }else{selector_DA.am_b=rbind(selector_DA.am_b,summary(fit2k_b)[["coefficients"]][name.da_b_k[2],3])}
    }
    count_cm.da.dm_b=as.numeric(abs(selector_DA.dm_b)>threshold | abs(selector_DA.am_b)>threshold)
    count_cm.da.am_b=as.numeric(abs(selector_DA.am_b)>threshold)
    count_cm.da_b=c(count_cm.da.dm_b,count_cm.da.am_b)
    
    if(sum(count_cm.da_b)==0){
      mse_b=sum((pairdata[x.out,"dLogTime"])^2)
      auc_b=0
    }else{
      f.cm.da_b <- as.formula(paste("dLogTime~", paste(c(colnames(DZ),colnames(AZ))[ifelse(count_cm.da_b==1,TRUE,FALSE)], collapse = " + ")))
      fitDA.cm_b=glm(f.cm.da_b, weight=wgt[x.in], data=pairdata[x.in,])
      pred.out=predict(fitDA.cm_b,newdata=pairdata[x.out,-1])
      mse_b=sum((pairdata[x.out,"dLogTime"]-pred.out)^2)
      auc_b=auc(roc(as.numeric(pairdata[x.out,"dLogTime"]>0),as.numeric(pred.out>0),direction = "<"))
    }
    
    n.out_b=length(x.out)
    return(c(mse_b,n.out_b,auc_b))
  }
  
  OOB.sda=apply(bootsamid1,1,Predcm.DA)
  OOBSDA=c(mean(sqrt(OOB.sda[1,]/OOB.sda[2,])),mean(OOB.sda[3,]))
  return(OOBSDA)
}


esiCMDA=function(thd){
  count_cm.da.am=as.numeric(abs(resultDAam[,"selectorDA"])>thd)
  count_cm.da.dm=as.numeric(abs(resultDAdm[,"selectorDA"])>thd | abs(resultDAam[,"selectorDA"])>thd)
  count_cm.da=c(count_cm.da.dm,count_cm.da.am)
  if(sum(count_cm.da)==0){ResultDAcm_s=matrix(0,2*p+1,9)}else{
    f.cm.da <- as.formula(paste("dLogTime~", paste(c(colnames(DZ),colnames(AZ))[ifelse(count_cm.da==1,TRUE,FALSE)], collapse = " + ")))
    fit.cm.da=glm(f.cm.da, weight=wgt,data=pairdata)
    thetaCM.DA=function(x,data){
      f <- as.formula(paste("dLogTime~", paste(c(colnames(DZ),colnames(AZ))[ifelse(count_cm.da==1,TRUE,FALSE)], collapse = " + ")))
      fit = glm(f, weight=wgt[x], data=data[x,])
      coefv = fit[["coefficients"]]
      coefv[which(is.na(coefv))]=0
      return(coefv)
    }
    if(is.na(sum(fit.cm.da[["coefficients"]]))){
      summaryfitCMda=apply(summary(fit.cm.da)[["coefficients"]],2,assignbeta,count=1-as.numeric(is.na(fit.cm.da[["coefficients"]])))
    }else{
      summaryfitCMda=summary(fit.cm.da)[["coefficients"]]
    }
    rownames(summaryfitCMda)=c("(Intercept)",c(colnames(DZ),colnames(AZ))[ifelse(count_cm.da==1,TRUE,FALSE)])
    
    thetastarDACM=apply(bootsamid1,1,thetaCM.DA, data=pairdata)
    #bootstrap mean
    btsmeanDACM=as.matrix(rowMeans(thetastarDACM))
    #bootstrap sd
    btssdDACM=apply(thetastarDACM,1,sd)
    #simple corrected bootstrap mean
    bcbtsmeanDACM=2*summaryfitCMda[,"Estimate"]-btsmeanDACM
    #bootstrap asymptotic Normal CI
    asybtsDACM=cbind(btsmeanDACM-btssdDACM*qnorm(0.975),
                     btsmeanDACM-btssdDACM*qnorm(0.025))
    resultDAcm=cbind(
      summaryfitCMda,
      btsmeanDACM,
      btssdDACM,
      bcbtsmeanDACM,
      asybtsDACM)
    colnames(resultDAcm)=c("est","est.se","t","p","bts.est","bts.sd","bcbts.est","bts.asy.L","bts.asy.U")
    ResultDAcm_s=cbind(True=c(Beta[-1],Beta_intr), apply(resultDAcm, 2, assignbeta,count=c(1,count_cm.da)))
    rownames(ResultDAcm_s)=c("Trt",names(DZ),names(AZ))
    cvrtDA.CM=as.numeric(apply(cbind(c(Beta[-1],Beta_intr),ResultDAcm_s[,c("bts.asy.L","bts.asy.U")]), 1, BETWEENAll))
    ResultDAcm_s=cbind(ResultDAcm_s,cvrtDA.CM)
  }
  if(sum(count_cm.da)==0){
    mse.sda=sqrt(mean((dLogTime.TS)^2))
    auc.sda=0.5
  }else{
    pred.out=predict(fit.cm.da,newdata=Z.TS)
    mse.sda=sqrt(mean((dLogTime.TS-pred.out)^2))
    auc.sda=suppressMessages(auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out>0),direction = "<")))
  }
  TS.sda=c(mse.sda,auc.sda)
  result=list()
  result[[1]]=ResultDAcm_s
  result[[2]]=TS.sda
  return(result)
}

SDA=esiCMDA(thd)
Selection.DA=SDA[[1]]
TS.selection.DA=SDA[[2]]
OOB.selection.DA=selectDAOOB(thd)

########################  MW.OLS_SA_All########################################
########################  MW.OLS_SA_All########################################
########################  MW.OLS_SA_All########################################
selectAOOB=function(threshold){
  #################if select based on A+D, also contain D and A in combined terms################
  count_cm.a=as.numeric(abs(selectA[,"selectorA"])>threshold)
  f.cm.a <- as.formula(paste("dLogTime~", paste(colnames(AZ)[ifelse(count_cm.a==1,TRUE,FALSE)], collapse = " + ")))
  fit.cm.a=glm(f.cm.a, weight=wgt,data=pairdata)
  
  Predcm.A = function(x.in){
    x.out=c(1:npair)[-unique(x.in)]
    if(length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
      while (length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
        x.in=sample(1:npair,size=npair,replace=TRUE)
        x.out=c(1:npair)[-unique(x.in)]
      }
    }
    selector_A_b=NULL
    for (k in 1:dim(DZ)[2]) {
      
      #######pick the kth moderator
      pairdata.a_b_k=pairdata[x.in,c(1,1+p+k)]
      name.a_b_k <- names(pairdata.a_b_k)[-1]
      f.a_b_k <- as.formula(paste("dLogTime~", paste(name.a_b_k, collapse = " + ")))
      fit3k_b=glm(f.a_b_k,weight=wgt[x.in], data=pairdata.a_b_k)
      selector_A_b=rbind(selector_A_b,summary(fit3k_b)[["coefficients"]][name.a_b_k,3])
      
    }
    
    count_cm.a_b=as.numeric(abs(selector_A_b)>threshold)
    
    if(sum(count_cm.a_b)==0){
      mse_b=sum((pairdata[x.out,"dLogTime"])^2)
      auc_b=0.5
    }else{
      f.cm.a_b <- as.formula(paste("dLogTime~", paste(c(colnames(DZ),colnames(AZ))[ifelse(count_cm.a_b==1,TRUE,FALSE)], collapse = " + ")))
      fitA.cm_b=glm(f.cm.a_b,weight=wgt[x.in], data=pairdata[x.in,])
      pred.out=predict(fitA.cm_b,newdata=pairdata[x.out,-1])
      mse_b=sum((pairdata[x.out,"dLogTime"]-pred.out)^2)
      auc_b=auc(roc(as.numeric(pairdata[x.out,"dLogTime"]>0),as.numeric(pred.out>0),direction = "<"))
    }
    n.out_b=length(x.out)
    return(c(mse_b,n.out_b,auc_b))
  }
  OOB.sa=apply(bootsamid1,1,Predcm.A)
  OOBSA=c(mean(sqrt(OOB.sa[1,]/OOB.sa[2,])),mean(OOB.sa[3,]))
  return(OOBSA)
}


esiCMA=function(thd_A){
  count_cm.a=as.numeric(abs(selectA[,"selectorA"])>thd_A)
  if(sum(count_cm.a)==0){ResultAcm_s=matrix(0,1+p,9)}else{
    f.cm.a <- as.formula(paste("dLogTime~", paste(colnames(AZ)[ifelse(count_cm.a==1,TRUE,FALSE)], collapse = " + ")))
    fit.cm.a=glm(f.cm.a, weight=wgt,data=pairdata)
    
    thetaCM.A = function(x,data){
      f <- as.formula(paste("dLogTime~", paste(colnames(AZ)[ifelse(count_cm.a==1,TRUE,FALSE)], collapse = " + ")))
      fit = glm(f,weight=wgt[x], data=data[x,])
      coefv = fit[["coefficients"]]
      coefv[which(is.na(coefv))]=0
      return(coefv)
    }
    
    thetastarACM=apply(bootsamid1,1,thetaCM.A,data=pairdata)
    #bootstrap mean
    btsmeanACM=as.matrix(rowMeans(thetastarACM))
    #bootstrap sd
    btssdACM=apply(thetastarACM,1,sd)
    #simple corrected bootstrap mean
    bcbtsmeanACM=2*summary(fit.cm.a)[["coefficients"]][,1]-btsmeanACM
    #bootstrap asymptotic Normal CI
    asybtsACM=cbind(btsmeanACM-btssdACM*qnorm(0.975),
                    btsmeanACM-btssdACM*qnorm(0.025))
    
    resultAcm=cbind(
      summary(fit.cm.a)[["coefficients"]],
      btsmeanACM,
      btssdACM,
      bcbtsmeanACM,
      asybtsACM)
    colnames(resultAcm)=c("est","est.se","t","p","bts.est","bts.sd","bcbts.est","bts.asy.L","bts.asy.U")
    ResultAcm_s=cbind(True=c(Beta[2],Beta_intr), apply(resultAcm, 2, assignbeta,count=c(1,count_cm.a)))
    rownames(ResultAcm_s)=c("Trt",nameM)
    cvrtA.CM=as.numeric(apply(cbind(c(Beta[2],Beta_intr),ResultAcm_s[,c("bts.asy.L","bts.asy.U")]), 1, BETWEENAll))
    ResultAcm_s=cbind(ResultAcm_s,cvrtA.CM)
  }
  
  if(sum(count_cm.a)==0){
    mse.sa=sqrt(mean((dLogTime.TS)^2))
    auc.sa=0.5
  }else{
    pred.out.sa=predict(fit.cm.a,newdata=Z.TS[,-c(1:p)])
    mse.sa=sqrt(mean((dLogTime.TS-pred.out.sa)^2))
    auc.sa=suppressMessages(auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.sa>0),direction = "<")))
  }
  TS.sa=c(mse.sa,auc.sa)
  result=list()
  result[[1]]=ResultAcm_s
  result[[2]]=TS.sa
  return(result)
}

SA=esiCMA(thd)
Selection.A=SA[[1]]
TS.selection.A=SA[[2]]
OOB.selection.A=selectAOOB(thd)

####################################IPCW Paired Data for Lasso and Random forest####################################
####################################IPCW Paired Data for Lasso and Random forest####################################
####################################IPCW Paired Data for Lasso and Random forest####################################
pairdata.w=pairdata*sqrt(wgt)

######MW.LDA##############################################
######MW.LDA##############################################
######MW.LDA##############################################
lambda_seq<-10^seq(2,-3,by = -.1)
thetaLassoDA=function(x.in){
  Y=as.matrix(pairdata.w[x.in,"dLogTime"])
  X.DA=model.matrix(dLogTime~. , pairdata.w)[x.in,-1]
  cv_output.DA <- cv.glmnet(X.DA, Y,alpha = 1, lambda = lambda_seq, nfolds = 5)
  lasso_best.DA <- glmnet(X.DA, Y, alpha = 1, lambda = cv_output.DA[["lambda.min"]])
  return(c(as.numeric(lasso_best.DA[["a0"]]),as.numeric(lasso_best.DA[["beta"]])))
}

Y=as.matrix(pairdata.w[,"dLogTime"])
X.DA=model.matrix(dLogTime~. , pairdata.w)[,-1]
cv_output.DA <- cv.glmnet(X.DA, Y, alpha = 1, lambda = lambda_seq, nfolds = 5)
lasso_best.DA <- glmnet(X.DA, Y, alpha = 1, lambda = cv_output.DA[["lambda.min"]])

thetastar.Lasso.DA=apply(bootsamid1,1,thetaLassoDA)
#bootstrap mean 
btsmean.Lasso.DA=as.matrix(rowMeans(thetastar.Lasso.DA))
#bootstrap sd
btssd.Lasso.DA=apply(thetastar.Lasso.DA,1,sd)
#simple corrected bootstrap mean
bcbtsmean.Lasso.DA=2*c(as.numeric(lasso_best.DA[["a0"]]),as.numeric(lasso_best.DA[["beta"]]))-btsmean.Lasso.DA
#bootstrap asymptotic Normal CI
asybts.Lasso.DA=cbind(btsmean.Lasso.DA-btssd.Lasso.DA*qnorm(0.975),
                      btsmean.Lasso.DA-btssd.Lasso.DA*qnorm(0.025))
cvrt.Lasso.DA=as.numeric(apply(cbind(c(Beta[-1],Beta_intr),asybts.Lasso.DA), 1, BETWEENAll))

LASSODA=cbind(c(Beta[-1],Beta_intr),c(as.numeric(lasso_best.DA[["a0"]]),as.numeric(lasso_best.DA[["beta"]])),btsmean.Lasso.DA,bcbtsmean.Lasso.DA,btssd.Lasso.DA,asybts.Lasso.DA,cvrt.Lasso.DA)
colnames(LASSODA)=c("True","est","bts.est","bcbts.est","bts.sd","bts.asy.L","bts.asy.U","cvrt")

######MW.LA###########################################
######MW.LA###########################################
######MW.LA###########################################
thetaLassoA=function(x.in){
  Y=as.matrix(pairdata.w[x.in,"dLogTime"])
  X.A=model.matrix(dLogTime~. , pairdata.w[x.in,-c(2:(1+p))])[,-1]
  cv_output.A <- cv.glmnet(X.A, Y,alpha = 1, lambda = lambda_seq,nfolds = 5)
  lasso_best.A <- glmnet(X.A, Y, alpha = 1, lambda = cv_output.A[["lambda.min"]])
  return(c(as.numeric(lasso_best.A[["a0"]]),as.numeric(lasso_best.A[["beta"]])))
}

X.A=model.matrix(dLogTime~. , pairdata.w[,-c(2:(1+p))])[,-1]
cv_output.A <- cv.glmnet(X.A, Y,alpha = 1, lambda = lambda_seq,nfolds = 5)
lasso_best.A <- glmnet(X.A, Y, alpha = 1, lambda = cv_output.A[["lambda.min"]])

thetastar.Lasso.A=apply(bootsamid1,1,thetaLassoA)
#bootstrap mean 
btsmean.Lasso.A=as.matrix(rowMeans(thetastar.Lasso.A))
#bootstrap sd
btssd.Lasso.A=apply(thetastar.Lasso.A,1,sd)
#simple corrected bootstrap mean
bcbtsmean.Lasso.A=2*c(as.numeric(lasso_best.A[["a0"]]),as.numeric(lasso_best.A[["beta"]]))-btsmean.Lasso.A
#bootstrap asymptotic Normal CI
asybts.Lasso.A=cbind(btsmean.Lasso.A-btssd.Lasso.A*qnorm(0.975),
                     btsmean.Lasso.A-btssd.Lasso.A*qnorm(0.025))
cvrt.Lasso.A=as.numeric(apply(cbind(c(Beta[2],Beta_intr),asybts.Lasso.A), 1, BETWEENAll))

LASSOA=cbind(c(Beta[2],Beta_intr),c(as.numeric(lasso_best.A[["a0"]]),as.numeric(lasso_best.A[["beta"]])),btsmean.Lasso.A,bcbtsmean.Lasso.A,btssd.Lasso.A,asybts.Lasso.A,cvrt.Lasso.A)
colnames(LASSOA)=c("True","est","bts.est","bcbts.est","bts.sd","bts.asy.L","bts.asy.U","cvrt")

##############################################
##random forest DA TS########################
##############################################
f.rf.da <- as.formula(paste("dLogTime~", paste(colnames(pairdata.w[,-1]), collapse = " + ")))
rf.starts.da = randomForest(f.rf.da, data=pairdata.w,ntree=250, norm.votes = TRUE)
pred.out.rf.da=predict(rf.starts.da, newdata=Z.TS, type="response")
mse.rf.da=sqrt(mean((dLogTime.TS-pred.out.rf.da)^2))
auc.rf.da=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.rf.da>0),direction = "<"))
TS.rf.DA=c(mse.rf.da,auc.rf.da)

#############################################
# random forest A only TS####################
#############################################
f.rf.a <- as.formula(paste("dLogTime~", paste(colnames(pairdata.w[,-c(1:(1+p))]), collapse = " + ")))
rf.starts.a = randomForest(f.rf.a, data=pairdata.w, ntree=250, norm.votes = TRUE)
pred.out.rf.a=predict(rf.starts.a, newdata=Z.TS[,-c(1:p)], type="response")
mse.rf.a=sqrt(mean((dLogTime.TS-pred.out.rf.a)^2))
auc.rf.a=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.rf.a>0), direction = "<"))
TS.rf.A=c(mse.rf.a,auc.rf.a)

##############################################
## random forest DA OOB#######################
##############################################
Pred.rf.DA = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  rf.starts = randomForest(f.rf.da, data=pairdata.w[x.in,], ntree=250, norm.votes = FALSE)
  pred.out=predict(rf.starts, newdata=pairdata[x.out,-1], type="response")
  mse_b=sum((dLogTime[x.out]-pred.out)^2)
  auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
}
OOB.rf.DA=apply(bootsamid1, 1, Pred.rf.DA)

##############################################
## random forest A only OOB###################
##############################################
Pred.rf.A = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  rf.starts = randomForest(f.rf.a, data=pairdata.w[x.in,-c(2:(1+p))], ntree=250, norm.votes = FALSE)
  pred.out=predict(rf.starts, newdata=pairdata[x.out,-c(1:(1+p))], type="response")
  mse_b=sum((dLogTime[x.out]-pred.out)^2)
  auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
}
OOB.rf.A=apply(bootsamid1, 1, Pred.rf.A)

##############################################
###########MW.LDA TS##########################
############################################## 
pred.out.l.da=predict(lasso_best.DA, s=cv_output.DA[["lambda.min"]], newx=as.matrix(Z.TS))
mse.l.da=sqrt(mean((dLogTime.TS-pred.out.l.da)^2))
auc.l.da=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.l.da>0),direction = "<"))
TS.lasso.DA=c(mse.l.da,auc.l.da)

##############################################
###########MW.LA TS###########################
############################################## 
pred.out.l.a=predict(lasso_best.A, s=cv_output.A[["lambda.min"]], newx=as.matrix(Z.TS[,-c(1:p)]))
mse.l.a=sqrt(mean((dLogTime.TS-pred.out.l.a)^2))
auc.l.a=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.l.a>0),direction = "<"))
TS.lasso.A=c(mse.l.a,auc.l.a)

##############################################
###########MW.LDA OOB#########################
############################################## 
Pred.lasso.DA = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  Y=as.matrix(pairdata.w[x.in,"dLogTime"])
  X=model.matrix(dLogTime~. , pairdata.w[x.in,])[,-1]
  cv_output <- cv.glmnet(X, Y,alpha = 1, lambda = lambda_seq, nfolds = 5)
  lasso_best <- glmnet(X, Y, alpha = 1, lambda = cv_output[["lambda.min"]])
  pred.out=predict(lasso_best,newx=as.matrix(pairdata[x.out,-1]))
  mse_b=sum((dLogTime[x.out]-pred.out)^2)
  auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
  
}

OOB.lasso.DA=apply(bootsamid1, 1, Pred.lasso.DA)

##############################################
###########MW.LA OOB##########################
############################################## 
Pred.lasso.A = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata.w[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  Y=as.matrix(pairdata.w[x.in,"dLogTime"])
  X=model.matrix(dLogTime~. , pairdata.w[x.in,-c(2:(1+p))])[,-1]
  cv_output <- cv.glmnet(X, Y, alpha = 1, lambda = lambda_seq, nfolds = 5)
  lasso_best <- glmnet(X, Y, alpha = 1, lambda = cv_output[["lambda.min"]])
  pred.out=predict(lasso_best,newx=as.matrix(pairdata[x.out,-c(1:(1+p))]))
  mse_b=sum((dLogTime[x.out]-pred.out)^2)
  auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
  
}

OOB.lasso.A=apply(bootsamid1, 1, Pred.lasso.A)

##############################################
###########MW.OLS.DA.All TS###################
############################################## 
pred.out.all.da=predict(fit.all.DA,newdata=Z.TS)
mse.all.da=sqrt(mean((dLogTime.TS-pred.out.all.da)^2))
auc.all.da=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.all.da>0),direction = "<"))
TS.all.DA=c(mse.all.da,auc.all.da)
##############################################
###########MW.OLS.DA.All OOB##################
############################################## 
Pred.DA = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  fitDA.all=glm(dLogTime ~ .,weight=wgt[x.in], data=pairdata[x.in,])
  pred.out=predict(fitDA.all, newdata=pairdata[x.out,])
  mse_b=sum((dLogTime[x.out]-pred.out)^2)
  auc_b=auc(roc(as.numeric(dLogTime[x.out]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
}
OOBall.DA=apply(bootsamid1, 1, Pred.DA)

##############################################
###########MW.OLS.A.All TS####################
############################################## 
pred.out.all.a=predict(fit.all.A,newdata=Z.TS[,-c(1:p)])
mse.all.a=sqrt(mean((dLogTime.TS-pred.out.all.a)^2))
auc.all.a=auc(roc(as.numeric(dLogTime.TS>0),as.numeric(pred.out.all.a>0),direction = "<"))
TS.all.A=c(mse.all.a,auc.all.a)
##############################################
###########MW.OLS.A.All OOB###################
############################################## 
Pred.A = function(x.in){
  x.out=c(1:npair)[-unique(x.in)]
  if(length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
    while (length(unique(pairdata[x.out,"dLogTime"]>0))!=2){
      x.in=sample(1:npair,size=npair,replace=TRUE)
      x.out=c(1:npair)[-unique(x.in)]
    }
  }
  fitA.all=glm(dLogTime ~ .,weight=wgt[x.in], data=pairdata[x.in,-c(2:(1+p))])
  pred.out=predict(fitA.all, newdata=pairdata[x.out,-c(1:(1+p))])
  mse_b=sum((pairdata[x.out,"dLogTime"]-pred.out)^2)
  auc_b=auc(roc(as.numeric(pairdata[x.out,"dLogTime"]>0),as.numeric(pred.out>0),direction = "<"))
  n.out_b=length(x.out)
  return(c(mse_b,n.out_b,auc_b))
}

OOBall.A=apply(bootsamid1, 1, Pred.A)
############################################################
############################################################
############################################################
#Summarize Evaluation results
TS=matrix(0,8,2)
TS[1,]=TS.all.A
TS[2,]=TS.all.DA
TS[3,]=TS.selection.DA
TS[4,]=TS.selection.A
TS[5,]=TS.lasso.A
TS[6,]=TS.lasso.DA
TS[7,]=TS.rf.A
TS[8,]=TS.rf.DA
rownames(TS)=c("AllA","AllDA","SDA","SA","LA","LDA","RFA","RFDA")
colnames(TS)=c("TSPE","TSAUC")

OOB=matrix(0,8,2)
OOB[1,]=c(mean(sqrt(OOBall.A[1,]/OOBall.A[2,])),mean(OOBall.A[3,]))
OOB[2,]=c(mean(sqrt(OOBall.DA[1,]/OOBall.DA[2,])),mean(OOBall.DA[3,]))
OOB[3,]=OOB.selection.DA
OOB[4,]=OOB.selection.A
OOB[5,]=c(mean(sqrt(OOB.lasso.A[1,]/OOB.lasso.A[2,])),mean(OOB.lasso.A[3,]))
OOB[6,]=c(mean(sqrt(OOB.lasso.DA[1,]/OOB.lasso.DA[2,])),mean(OOB.lasso.DA[3,]))
OOB[7,]=c(mean(sqrt(OOB.rf.A[1,]/OOB.rf.A[2,])),mean(OOB.rf.A[3,]))
OOB[8,]=c(mean(sqrt(OOB.rf.DA[1,]/OOB.rf.DA[2,])),mean(OOB.rf.DA[3,]))
rownames(OOB)=c("allA","allDA","SDA","SA","LA","LDA","RFA","RFDA")
colnames(OOB)=c("OOBPE","OOBAUC")
Evaluation=round(cbind(TS,OOB),2)

#summarize Estimation results
Estimation=round(cbind(c(Beta[3:17],Beta_intr),resultDA[,1:2],
                       rbind(matrix(0,p,2),resultA[,1:2]),
                       result.all.DA[-1,1:2],
                       rbind(matrix(0,p,2),result.all.A[-1,1:2]),
                       Selection.DA[-1,1:2],
                       rbind(matrix(0,p,2),Selection.A[-1,1:2]),
                       LASSODA[-1,1:2],
                       rbind(matrix(0,p,2),LASSOA[-1,1:2])),2)

colnames(Estimation)=c("TRUE","UDA_Est","UDA_SE", "UA_Est","UA_SE","AllDA_Est","AllDA_SE","AllA_Est","AllA_SE","SDA_Est","SDA_SE","SA_Est","SA_SE","LDA_Est","LDA_SE","LA_Est","LA_SE")
rownames(Estimation)=c(paste0("Z",seq(1:15)),paste0("Z",seq(1:15),"_intr"))

Estimation
Evaluation

